﻿using System;
using System.Collections.Generic;
using swivelsecure.client;

public partial class AddUser : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

    }

    protected void BtnCancelClick(object sender, EventArgs e) {
        Response.Redirect("./ListUsers.aspx");
    }

    protected void BtnAddClick(object sender, EventArgs e) {
        if (String.IsNullOrEmpty(txtUsername.Text)) {
            lblResult.Text = "No username entered";
            return;
        }
        SwivelAdminRequest req = new SwivelAdminRequest();
        SwivelUser user = new SwivelUser(req, txtUsername.Text);
	    if (req.AllowUserAttributes()) {
			user.SetUserAttribute("givenname", txtFirstName.Text);
			user.SetUserAttribute("familyname", txtSurname.Text);
		    user.SetUserAttribute("email", txtEmail.Text);
			user.SetUserAttribute("phone", txtMobile.Text);
	    } else {
		    // NOTE: this example assumes that you are using email for alerts and AQL for security strings.
		    if (!String.IsNullOrEmpty(txtEmail.Text)) {
			    user.SetAlertTransport("SMTP", txtEmail.Text);
		    }
		    if (!String.IsNullOrEmpty(txtMobile.Text)) {
			    user.SetStringTransport("AQL", txtMobile.Text);
		    }
	    }
	    // NOTE: this example assumes that all users are added to the PINsafeUsers group.
        user.Groups = new List<string> { "PINsafeUsers" };
        user.Grant(SwivelUserRight.single, SwivelUserRight.dual, SwivelUserRight.swivlet);
        req.CreateUser(user);
        lblResult.Text = (req.Send() ? "User \"" + txtUsername.Text + "\" added to Swivel" : "Error adding new user");
    }
}