﻿using System;
using System.Collections.Generic;
using swivelsecure.client;

public partial class EditUser : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e) {
        if (!IsPostBack) {
            string username = Request["username"];
            if (string.IsNullOrEmpty(username)) {
                lblResult.Text = "No username specified";
                btnSave.Enabled = false;
                return;
            }
            txtUsername.Text = username;
            SwivelAdminRequest req = new SwivelAdminRequest();
            SwivelUser user = new SwivelUser(req, username);
            req.ReadUser(user);
            if (!req.Send()) {
                lblResult.Text = "Error retrieving the user \"" + username + "\"";
                btnSave.Enabled = false;
                return;
            }
            ReadResponseUser respUser = req.Response.ReadSingleUser();
            if (respUser == null) {
                lblResult.Text = "Unable to find user \"" + username + "\"";
                return;
            }
            txtUsername.Text = respUser.Name;
	        if (req.AllowUserAttributes()) {
		        txtFirstName.Text = (respUser.Attributes.ContainsKey("givenname") ? respUser.Attributes["givenname"] : "");
		        txtSurname.Text = (respUser.Attributes.ContainsKey("familyname") ? respUser.Attributes["familyname"] : "");
		        txtEmail.Text = (respUser.Attributes.ContainsKey("email") ? respUser.Attributes["email"] : "");
		        txtMobile.Text = (respUser.Attributes.ContainsKey("phone") ? respUser.Attributes["phone"] : "");
	        } else {
		        txtFirstName.Text = "";
		        txtFirstName.Enabled = false;
		        txtSurname.Text = "";
		        txtSurname.Enabled = false;
		        ReadResponseUser.Transport alertTransport = respUser.AlertTransport;
		        if (alertTransport != null) {
			        txtEmail.Text = alertTransport.Destination;
		        }
		        ReadResponseUser.Transport stringTransport = respUser.StringTransport;
		        if (stringTransport != null) {
			        txtMobile.Text = stringTransport.Destination;
		        }
	        }
        }
    }

    protected void BtnCancelClick(object sender, EventArgs e) {
        Response.Redirect("./ListUsers.aspx");
    }

    protected void BtnEditClick(object sender, EventArgs e) {
        SwivelAdminRequest req = new SwivelAdminRequest();
        SwivelUser user = new SwivelUser(req, txtUsername.Text);
	    if (req.AllowUserAttributes()) {
		    user.SetUserAttribute("givenname", txtFirstName.Text);
		    user.SetUserAttribute("familyname", txtSurname.Text);
		    user.SetUserAttribute("email", txtEmail.Text);
		    user.SetUserAttribute("phone", txtMobile.Text);
	    } else {
		    // NOTE: this example assumes that you are using email for alerts and AQL for security strings.
		    if (!String.IsNullOrEmpty(txtEmail.Text)) {
			    user.SetAlertTransport("SMTP", txtEmail.Text);
		    }
		    if (!String.IsNullOrEmpty(txtMobile.Text)) {
			    user.SetStringTransport("AQL", txtMobile.Text);
		    }
	    }
	    // NOTE: this example assumes that all users are added to the PINsafeUsers group.
        user.Groups = new List<string> { "PINsafeUsers" };
        user.Grant(SwivelUserRight.single, SwivelUserRight.dual, SwivelUserRight.swivlet);
        req.UpdateUser(user);
        lblResult.Text = (req.Send() ? "User \"" + txtUsername.Text + "\" updated successfully" : "Error updating user");
    }
}