﻿using System;
using System.Collections.Generic;
using swivelsecure.client;

public partial class ListUsers : System.Web.UI.Page {
	private const String REPOSITORY = "LocalRepos";
	List<string> users;

    protected void Page_Load(object sender, EventArgs e) {
	    LoadUsers();
    }

	private void LoadUsers() {
		SwivelAdminRequest req = new SwivelAdminRequest();
		SwivelReport rep = new SwivelReport(req);
		rep.SetRepository(REPOSITORY);
		rep.RequestAll();
		req.Report(rep);
		req.Send();
		SwivelAdminAPIResponse resp = req.Response;
		users = resp.AllUsers;
		string selectedUser = Listbox1.SelectedValue;
		Listbox1.Items.Clear();
		if (users != null) {
			foreach (string user in users) {
				Listbox1.Items.Add(user);
				if (string.Compare(user, selectedUser, StringComparison.OrdinalIgnoreCase) == 0) {
					Listbox1.Items[Listbox1.Items.Count - 1].Selected = true;
				}
			}
		} else {
			lblResult.Text = "No users found";
		}
	}

	protected void BtnAddClick(object sender, EventArgs e) {
        Response.Redirect("./AddUser.aspx");
    }

    protected void BtnEditClick(object sender, EventArgs e) {
        if (Listbox1.SelectedIndex < 0) {
            lblResult.Text = "No user selected";
            return;
        }
        Response.Redirect("./EditUser.aspx?username=" + Listbox1.SelectedValue);
    }

    protected void BtnDeleteClick(object sender, EventArgs e) {
        if (Listbox1.SelectedIndex < 0) {
            lblResult.Text = "No user selected";
            return;
        }
        Response.Redirect("./DeleteUser.aspx?username=" + Listbox1.SelectedValue);
    }

	protected void BtnUpdateClick(object sender, EventArgs e) {
		LoadUsers();
	}
}